<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import AwsMarketoForm from '~/components/partners/technology-partners/form.vue';
import { NextStepAlt, VideoLooping } from '~/components/common/index.vue';
import { FooterEditLinkMixin } from '~/mixins';
import BySolutionBenefits from '~/components/solutions/by-solution/by-solution-benefits.vue';
import {
  Accordion,
  SolutionsHero as Hero,
} from '~/components/solutions/index.vue';

export default Vue.extend({
  components: {
    AwsMarketoForm,
    Accordion,
    BySolutionBenefits,
    Hero,
    NextStepAlt,
    VideoLooping,
  },
  mixins: [FooterEditLinkMixin],
  layout: 'no-banner',
  async asyncData({ $content, i18n }: any) {
    try {
      const data = await $content(
        `${i18n.locale}/partners/technology-partners/aws`,
      ).fetch();
      const { seo, content } = data;
      return { seo, content };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      isOpenIndex: -1 as number,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).seo,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  methods: {
    toggleController(index: number) {
      if (this.isOpenIndex === index) {
        this.isOpenIndex = null;
        return;
      }
      this.isOpenIndex = index;
    },
  },
  nuxtI18n: {
    locales: ['de-de', 'fr-fr', 'en-us', 'ja-jp', 'it-it', 'es', 'pt-br'],
  },
});
</script>

<template>
  <div>
    <Hero :data="content.hero" class="hero" />
    <SlpContainer
      variant="light-purple-100"
      class="slp-pt-48 slp-pb-48 slp-py-md-96"
    >
      <SlpRow>
        <SlpColumn :cols="8">
          <SlpTypography tag="h3" variant="heading3-bold" class="slp-pb-16">
            {{ content.section.title }}
          </SlpTypography>
          <SlpTypography variant="body1" class="description">
            {{ content.section.description }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
      <SlpRow class="slp-py-48 card-wrapper">
        <SlpColumn
          v-for="(card, index) in content.section.cards"
          :key="index"
          class="card"
        >
          <SlpIcon
            :name="card.config.icon"
            :variant="card.config.variant"
            size="48"
            :class="index === 0 ? 'icon--override' : ''"
          />
          <SlpTypography tag="h4" variant="heading4-bold" class="slp-my-16">
            {{ card.title }}
          </SlpTypography>
          <SlpTypography tag="p" variant="body2">
            {{ card.description }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
      <SlpRow>
        <SlpColumn class="slp-py-32 slp-px-24">
          <img
            :src="content.section.quote.logo"
            style="width: 200px; display: block"
          />
          <SlpTypography tag="p" variant="heading5" class="slp-my-16 quote">
            “{{ content.section.quote.text }}”
          </SlpTypography>
          <SlpTypography tag="p" variant="body2-bold">
            {{ content.section.quote.name }}
          </SlpTypography>
          <SlpTypography tag="p" variant="body2">
            {{ content.section.quote.title }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
    <VideoLooping v-bind="content.videoLooping" />
    <SlpContainer
      id="interest"
      class="formSectionWrapper color-surface-700"
      fluid
    >
      <SlpContainer>
        <SlpRow>
          <SlpColumn class="formLeft">
            <nuxt-img
              src="/nuxt-images/partners/aws/duo-with-amazon.svg"
              class="slp-mb-32"
              style="width: 100%"
            />
            <SlpTypography variant="heading5" tag="p">
              {{ content.formSection.description }}
            </SlpTypography>
            <SlpButton
              class="slp-my-24"
              variant="tertiary"
              v-bind="content.formSection.button.config"
            >
              {{ content.formSection.button.text }}
              <SlpIcon name="chevron-lg-right" variant="product" />
            </SlpButton>
            <div class="items-wrapper">
              <Accordion
                v-for="(item, index) in content.formSection.items"
                :key="item.title"
                class="accordion"
                :data="item"
                :is-open="isOpenIndex == index"
                @toggleController="toggleController(index)"
              />
            </div>
          </SlpColumn>
          <SlpColumn>
            <AwsMarketoForm :data="content.form" />
          </SlpColumn>
        </SlpRow>
      </SlpContainer>
    </SlpContainer>
    <BySolutionBenefits :data="content.accordion" class="color-surface-800" />
    <NextStepAlt />
  </div>
</template>

<style lang="scss" scoped>
.hero {
  margin: 0;

  &:deep {
    .slp-btn {
      background-color: $color-surface-700;

      &:hover {
        background-color: white;
        color: $color-surface-700;
      }
    }

    .container {
      padding: 0 16px;
    }

    .container .image {
      border-radius: 8px;
      width: 100%;
    }

    .footnote {
      margin-bottom: $spacing-32;

      @media (min-width: $breakpoint-md) {
        margin-bottom: initial;
      }
    }
  }
}

.formSectionWrapper {
  padding: $spacing-48 0;

  @media (min-width: $breakpoint-md) {
    padding: $spacing-96 0;
  }
}

.description {
  color: $color-text-200;
}

.icon--override {
  stroke-width: 1px !important;
}

.card-wrapper {
  gap: 16px;

  @media (min-width: $breakpoint-md) {
    flex-wrap: nowrap;
  }
}

.card {
  background: white;
  padding: 24px;
  border-radius: $spacing-8;
}

.formLeft {
  color: white;

  a {
    color: white;
  }
}

.accordion {
  &:deep {
    span {
      color: white;
    }
  }
}

.color-surface-800 {
  background: $color-surface-800;
}

.color-surface-700 {
  background: $color-surface-700;
}

.quote {
  font-style: italic;
  font-size: 22px;
  line-height: 36px;

  @media (min-width: $breakpoint-md) {
    padding-right: $spacing-64;
  }
}

.items-wrapper {
  margin-top: $spacing-32;
  margin-bottom: $spacing-48;
  width: 100%;

  &:deep .accordion,
  &:deep .accordion__header,
  &:deep .slp-icon {
    color: $color-text-50;
  }
  &:deep .accordion__icon:before,
  &:deep .accordion__icon:after {
    background-color: $color-text-50;
  }

  &:deep .accordion .summary {
    border-top: 1px solid $color-surface-600;
  }

  &:deep .content {
    color: $color-surface-400;

    a {
      color: $color-accent-400;
    }
  }

  &:deep .accordion__header {
    font-size: 22px;
    letter-spacing: -0.48px;

    @media (min-width: $breakpoint-md) {
      padding-right: $spacing-48;
      font-size: 24px;
      line-height: 28px;
    }
  }

  @media (max-width: 1169px) {
    max-width: 100%;
  }
  & > :last-child {
    margin-bottom: 0;
  }
}
</style>
